/*======================================================================*/
/*  GAMMA GENERIC INCLUDE FILE                                          */
/*======================================================================*/

#include <linux/sched.h>        /*  "current->pid", "EXIT_ZOMBIE"       */
#include <asm/io.h>             /*  "outl", etc.                        */
#include <asm/system.h>         /*  "local_save_flags", etc.            */
#include <linux/mm.h>           /*  "GFP_KERNEL", etc.                  */
#include <asm/pgtable.h>        /*  "pte_page", "pte_offset", etc.      */
#include <asm/uaccess.h>        /*  "copy_from_user", "copy_to_user"    */
#include <linux/linkage.h>	/*  "ALIGN", "ENTRY(name)"              */
#include <linux/netdevice.h>	/*  "struct device"                     */
#include <asm/atomic.h>
#ifdef MODULE
#include <linux/module.h>
#endif

typedef struct task_struct task_t;

/*  DO NOT CHANGE THE ORDER OF WHAT FOLLOWS!!  */

#include "gamma_def.h"

#if CPU == 32
extern struct desc_struct idt_table[];
#elif CPU == 64
#include <asm/desc.h>           /*  "struct gate_struct idt_table[]     */
#else
#warning CPU is neither 32- nor 64-bit ?!?
#endif

#include "lib/gamma_userlev.h"
#include "gamma_nic_dependent.h"
#include "gamma_macros.h"
#include "gamma_header.h"
#include "gamma_types.h"

asmlinkage int gamma_system_call(void);		/* Used by gamma_entry.S */
asmlinkage int gamma_ret_from_handler(void);	/* Used by gamma_entry.S */
void gamma_start(void);				/* Used by the device driver */
int rx_gamma(struct net_device *);
						/* Used by the device driver */
void gamma_kernel_send(
	unsigned long, unsigned char, unsigned char, void *, unsigned short,
	int
);	/* Used in file sys_gamma_vm.c */
long sys_gamma_vm_destroy(unsigned long);   /* Used by sys_gamma_vm_create() */
long __sys_gamma_vm_abort(unsigned long,int,int);  /* gamma_kernel_rec() */

extern unsigned long num_gamma_devices;		/* Used by the device driver */
extern struct net_device *gamma_devices[MAX_NUM_NICS];

#ifdef USE_DAMNICK
int damnick_icopy_k2u(void *, void *, unsigned long);
int damnick_icopy_k2u_nu
	(void *, void *, unsigned long, unsigned long *, unsigned long);
int damnick_writel_u(unsigned long *, unsigned long);
#endif
