/***************************************************************************
	Read COPYRIGHT file in this directory
****************************************************************************/


typedef union {
	u32 ll;
	u16 ss[2];
} l2s;

typedef struct {
	unsigned short partner_instnum;
	unsigned short partner_port;
	unsigned char partner_par_pid;
	unsigned char partner_procnum;
	unsigned short phys_partner_node;
	unsigned char buffer_kind;
	unsigned char boundary_1p;
	unsigned short semaphore;
	void *in_buffer;

	unsigned int in_size;
	void *in_progress;
	unsigned int in_room;
/*  Added this to support Lars' GAMMA sockets in multithreaded programs     */
	struct task_struct *task;    /* thread who uses this port for input */

#ifdef MORE_INSTANCES_ON_SAME_NODE
	unsigned char partner_is_same_node;
	unsigned char bcast_was_susp;
	unsigned short dummy1;       /* alignment                           */
#endif
	int suspended_isend_handle;  /* Signed:  Default value is < 0       */
	void *current_tx_data1;
	unsigned int current_tx_len1;

	void *current_tx_data2;
	unsigned int current_tx_len2;
	unsigned int current_rx_msglen;
	l2s *header;
		/*
		 *  Header for frames, plus room for a possible payload
		 *  (first packet only).	
		 */

#ifdef MORE_NICS_SAMENODE_ROUTING
	unsigned int nic_idx;  /* the nic on which the remote partner is   */
#endif

} port_entry;

typedef struct {
	port_entry port_table[MAX_PORT_NUMBER+1];

	/*
	 *  Pointers to user-space variable "gamma_msglen", holding
	 *  the len of the last arrived msg.
	 */
	void *msglen_ptr;

#ifdef USE_DAMNICK
	void *sem1_table;
	void *pre_sem_table;
#endif

	volatile int pid;
/*
 *  The following is also present in the "port_entry" data struct,
 *  to allow multiple threads: different threads can use different
 *  input ports.  In that case, however, the "pid" is unneeded.
 */
	struct task_struct *task;
	int whoami;
		/*
		 *  "whoami" wrt the virtual GAMMA corresponding to this entry
		 *  Not unsigned because -1 ==
		 *  "not belonging to this virtual GAMMA"
		 */
} instance_entry;

typedef struct {
	u_int32_t num_instances;
	unsigned char node_list[MAX_NUM_NODES*MAX_NUM_LOCAL_INST];
	u_int32_t random_key;		/*  To distinguish between two       */
					/*  consecutive virtual GAMMAs       */
					/*  who happen to have same par_pid  */
} vm_descriptor;

typedef struct {
	unsigned int num_locinst;
	unsigned int quitting;
		/*  process instances of this group that run on local node   */
	instance_entry inst_table[MAX_NUM_LOCAL_INST];
	vm_descriptor vm;
	eth_addr eth_table[MAX_NUM_NODES*MAX_NUM_LOCAL_INST];
	char wish_flag[MAX_NUM_NODES*MAX_NUM_LOCAL_INST]; /*  Sign important */
} par_entry;
