#define TRAP_P0(name,res) \
do { \
	__asm__ __volatile__ ( \
		"int $0x21" \
		: \
		"=a"(res) \
		: \
		"0"((u_int64_t)name) \
	); \
} while (0)
#define TRAP_P1(name,res,p1) \
do { \
	u_int64_t D; \
	__asm__ __volatile__ ( \
		"int $0x21" \
		: \
		"=a"(res),"=D"(D) \
		: \
		"0"((u_int64_t)name), \
		"1"((u_int64_t)p1) \
	); \
} while (0)
#define TRAP_P2(name,res,p1,p2) \
do { \
	u_int64_t D,S; \
	__asm__ __volatile__ ( \
		"int $0x21" \
		: \
		"=a"(res),"=D"(D),"=S"(S) \
		: \
		"0"((u_int64_t)name), \
		"1"((u_int64_t)p1), \
		"2"((u_int64_t)p2) \
	); \
} while (0)
#define TRAP_P3(name,res,p1,p2,p3) \
do { \
	u_int64_t D,S,d; \
	__asm__ __volatile__ ( \
		"int $0x21" \
		: \
		"=a"(res),"=D"(D),"=S"(S),"=d"(d) \
		: \
		"0"((u_int64_t)name), \
		"1"((u_int64_t)p1), \
		"2"((u_int64_t)p2), \
		"3"((u_int64_t)p3) \
	); \
} while (0)
#define TRAP_P4(name,res,p1,p2,p3,p4) \
do { \
	u_int64_t D,S,d,c; \
	__asm__ __volatile__ ( \
		"int $0x21" \
		: \
		"=a"(res),"=D"(D),"=S"(S),"=d"(d),"=c"(c) \
		: \
		"0"((u_int64_t)name), \
		"1"((u_int64_t)p1), \
		"2"((u_int64_t)p2), \
		"3"((u_int64_t)p3), \
		"4"((u_int64_t)p4) \
	); \
} while (0)
#define TRAP_P5(name,res,p1,p2,p3,p4,p5) \
do { \
	u_int64_t D,S,d,c,r8; \
	__asm__ __volatile__ ( \
		"movq %5,%%r8; int $0x21" \
		: \
		"=a"(res),"=D"(D),"=S"(S),"=d"(d),"=c"(c),"=g"(r8) \
		: \
		"0"((u_int64_t)name), \
		"1"((u_int64_t)p1), \
		"2"((u_int64_t)p2), \
		"3"((u_int64_t)p3), \
		"4"((u_int64_t)p4), \
		"5"((u_int64_t)p5) \
		: \
		"r8" \
	); \
} while (0)
